//PID library
#include <PID_v1.h>

// Motor Variablen
int m1_dir = 6; 
int m1_speed = 3;
int m2_dir = 4;
int m2_speed = 5;

// Regler Variablen
double p,i,d; //Used for data from potentiometer
double Kp, Ki, Kd; //used for myPID
double Input, Output; //used for myPID
int outputMotor;  //Output vorgabe für Motoren
double Setpoint = 0.0; 

int thistime, now, lasttime;

// myPID object Konstruktor
PID myPID(&Input, &Output, &Setpoint, Kp, Ki, Kd, DIRECT);  

void start() //wie setup
{
  
  pinMode(m1_dir, OUTPUT);
  pinMode(m1_speed, OUTPUT);
  pinMode(m2_dir, OUTPUT);
  pinMode(m1_speed, OUTPUT);
  pinMode(A1, INPUT);
  pinMode(A2, INPUT);
  pinMode(A3, INPUT);

  myPID.SetMode(AUTOMATIC);
  myPID.SetOutputLimits(-240, 240);
  myPID.SetSampleTime(10);
}

//read potentiometer data
void readPID() {
  p = analogRead(A1);
  i = analogRead(A2);
  d = analogRead(A3);
  //Finale Verstärkungsfaktoren
  Kp = 60; 
  Ki = 51; 
  Kd = 1;
  // Im Betrieb verstellbare Faktoren
  //Kp = 80 * p/1023;
  //Ki = 80 * i/1023;
  //Kd = 5 * d/1023;
}


void printPID() {
  Serial.print("kp: ");
  Serial.print(Kp,3);
  Serial.print("\tki: ");
  Serial.print(Ki,3);
  Serial.print("\tkd: ");
  Serial.print(Kd,3);
}

void motorSteuerung() {
  
  //links
  if(Output < 0) {
    
    outputMotor = 255 + Output;
     
    digitalWrite(m1_dir, HIGH); // 15 = schnell , 255 = langsam
    digitalWrite(m2_dir, HIGH);
    analogWrite(m1_speed, outputMotor);
    analogWrite(m2_speed, outputMotor);
    
  }
  //rechts
  if(Output > 0) {
   
    outputMotor = Output;
    digitalWrite(m1_dir, LOW); // 240 = schnell, 1 = langsam
    digitalWrite(m2_dir, LOW);
    analogWrite(m1_speed, outputMotor);
    analogWrite(m2_speed, outputMotor);
    
  }
}

void routine() // wie loop()
{  
  
    //PID
    readPID();
    //printPID();
    //Input ist aktuelle Winkel des Roboters. ypr[1] wird von mpu_offsets berechnet
    Input = ypr[1] * 180/M_PI;
    //Serial.println(Input);
    //thistime = millis();
    //Serial.print("\t");
    //Serial.println(thistime);
    Serial.print("\t");
    Serial.println(Output);
    
    // Hiermit können die Verstärkungsfaktoren im Betrieb verändert werden
    myPID.SetTunings(Kp,Ki,Kd);
   
    //Motor
    //jedes mal wenn die compute() durchgeführt wird, so auch die motorsteuerung
    if(myPID.Compute() == 1) {
      motorSteuerung();
      
}
}
